<template>
  <single-pane :capt="structure.pageOptions.title">
    <div
      v-for="(i, key) in components"
      :key="key"
      class="row"
    >
      <div class="col-xs-12">
        <ob-table
          v-if="i.type==='table'"
          :columns="i.options.columns"
          :show-add-button="i.options.addBtn"
          :functional-panel="i.options.functionalPanel"
          :page-limit="15"
          :remote-opt="getObTableData"
          @select="onSelection"
          @add="onAdd"
        >
          <div
            slot="enabled"
            slot-scope="{ data }"
          >
            <div>
              <ob-checkbox
                v-model="data.item.enabled"
                :disabled="true"
              />
            </div>
          </div>
        </ob-table>
        <ObModal
          v-if="i.type==='modal'"
          ref="test-modal"
          :is-show-pagination="true"
        >
          {{ activeRow }}
        </ObModal>
        <ObInput
          v-if="i.type==='input'"
          :label="i.options.label"
          :placeholder="i.options.placeholder"
        />
        <ObSelect
          v-if="i.type==='select'"
          :remote-opt="{
            method: getDictionaryList,
            arguments: { dictionary: i.options.dictionary }
          }"
          :label="i.options.label"
          :placeholder="i.options.placeholder"
        />
      </div>
    </div>
  </single-pane>
</template>
<script>

import SinglePane from '../obComponents/obSinglePanels'
import ObModal from '../obComponents/obModal'
import ObTable from '../obComponents/obTable'
import ObCheckbox from '../obComponents/obCheckbox'
import ObInput from '../obComponents/obInput'
import ObSelect from '../obComponents/obSelect'
import api from '@/api'
import RestClient from '../api/RestClient'
let Client = new RestClient({ baseURL: 'http://localhost:3000' })

export default {
  name: 'Test',
  components: {
    ObModal,
    ObTable,
    ObCheckbox,
    ObInput,
    ObSelect,
    SinglePane
  },
  data () {
    return {
      items: [],
      columns: [],
      components: [],
      structure: {},
      activeRow: '0',
      urlItems: ''
    }
  },
  created () {
    api.constructor.getPageConstructor().then((response) => {
      this.structure = response.data.structure
      this.components = this.structure.components
      for (let i of this.components) {
        if (i.options.urlItems) {
          this.urlItems = i.options.urlItems
        }
      }
    })
  },
  methods: {
    async getDictionaryList ({ dictionary, page, size, query, sort }) {
      const response = await api.constructor.getOptions(dictionary, page, size, query, sort)
      console.log('response', response)
      return response
    },
    groupTitle (value) {
      return value ? 'Активен' : 'Неактивен'
    },
    onAdd (item) {
      this.activeRow = 'created'
      if (this.$refs['test-modal'][0]) {
        this.$refs['test-modal'][0].open()
      }
    },
    onSelection (item) {
      this.activeRow = item.title
      if (this.$refs['test-modal'][0]) {
        this.$refs['test-modal'][0].open()
      }
    },
    getColumnStyle (column) {
      return {
        width: `${column.width}px` || 'auto'
      }
    },
    getDatetime (data) {
      return `
          <div>${data.when.split('T')[0]}</div>
          <div>${data.when.split('T')[1]}</div>
        `
    },
    async getObTableData ({ page, size, query, sort, filters }) {
      let _sort = []
      if (sort) {
        let params = sort.split(',')
        _sort.push({ selector: params[0], desc: (params[1] === 'desc') })
      }
      let res = await Client.get(this.urlItems)
      if (res && res.data) {
        return res.data.items
      } else {
        this.$notification({ type: 'system_notification_error', message: 'Ошибка загрузки данных' })
        return res
      }
    }
  }
}
</script>

<style>
  .row{
    margin-bottom: 15px;
  }
</style>
